Loading...
Searching...
No Matches
juce::AudioParameterInt Class Reference

## Detailed Description

Provides a class of AudioProcessorParameter that can be used as an integer value with a given range.

See also
  AudioParameterFloat, AudioParameterBool, AudioParameterChoice

The documentation for this class was generated from the following file:

- juce_audio_processors_headless/utilities/juce_AudioParameterInt.h

Inheritance diagram for juce::AudioParameterInt:

## Public Member Functions

| AudioParameterInt (const ParameterID &parameterID, const String &parameterName, int minValue, int maxValue, int defaultValue, const AudioParameterIntAttributes &attributes={})
| Creates a AudioParameterInt with the specified parameters.
| AudioParameterInt (const ParameterID &parameterID, const String &parameterName, int minValue, int maxValue, int defaultValueIn, const String &parameterLabel, std::function< String(int value, int maximumStringLength)> stringFromInt=nullptr, std::function< int(const String &text)> intFromString=nullptr)
| Creates a AudioParameterInt with the specified parameters.
| ~AudioParameterInt () override
| Destructor.
int | get () const noexcept
| Returns the parameter's current value as an integer.
| operator int () const noexcept
| Returns the parameter's current value as an integer.
AudioParameterInt & | operator= (int newValue)
| Changes the parameter's current value to a new integer.
Range< int > | getRange () const noexcept
| Returns the parameter's range.
const NormalisableRange< float > & | getNormalisableRange () const override
| Returns the range of values that the parameter can take.
Public Member Functions inherited from juce::RangedAudioParameter
int | getNumSteps () const override
| Returns the number of steps for this parameter based on the normalisable range's interval.
float | convertTo0to1 (float v) const noexcept
| Normalises and snaps a value based on the normalisable range.
float | convertFrom0to1 (float v) const noexcept
| Denormalises and snaps a value based on the normalisable range.
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const AudioProcessorParameterWithIDAttributes &attributes={})
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const String &parameterLabel, Category parameterCategory=AudioProcessorParameter::genericParameter)
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
Public Member Functions inherited from juce::AudioProcessorParameterWithID
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const AudioProcessorParameterWithIDAttributes &attributes={})
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const String &parameterLabel, Category parameterCategory=AudioProcessorParameter::genericParameter)
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
String | getName (int) const override
| Returns the name to display for this parameter, which should be made to fit within the given string length.
String | getLabel () const override
| Some parameters may be able to return a label string for their units.
Category | getCategory () const override
| Returns the parameter's category.
String | getParameterID () const override
| Returns an ID that is unique to this parameter.
bool | isMetaParameter () const override
| Should return true if this parameter is a "meta" parameter.
bool | isAutomatable () const override
| Returns true if the host can automate this parameter.
bool | isOrientationInverted () const override
| This can be overridden to tell the host that this parameter operates in the reverse direction.
Public Member Functions inherited from juce::HostedAudioProcessorParameter
| AudioProcessorParameter () noexcept=default
| AudioProcessorParameter (int versionHint)
| The version hint supplied to this constructor is used in Audio Unit plugins to aid ordering parameter identifiers when JUCE_FORCE_USE_LEGACY_PARAM_IDS is not enabled.
Public Member Functions inherited from juce::AudioProcessorParameter
| AudioProcessorParameter () noexcept=default
| AudioProcessorParameter (int versionHint)
| The version hint supplied to this constructor is used in Audio Unit plugins to aid ordering parameter identifiers when JUCE_FORCE_USE_LEGACY_PARAM_IDS is not enabled.
virtual | ~AudioProcessorParameter ()
| Destructor.
void | setValueNotifyingHost (float newValue)
| A processor should call this when it needs to change one of its parameters.
void | beginChangeGesture ()
| Sends a signal to the host to tell it that the user is about to start changing this parameter.
void | endChangeGesture ()
| Tells the host that the user has finished changing this parameter.
virtual bool | isDiscrete () const
| Returns whether the parameter uses discrete values, based on the result of getNumSteps, or allows the host to select values continuously.
virtual bool | isBoolean () const
| Returns whether the parameter represents a boolean switch, typically with "On" and "Off" states.
int | getParameterIndex () const noexcept
| Returns the index of this parameter in its parent processor's parameter list.
void | setParameterIndex (int) noexcept
virtual String | getCurrentValueAsText () const
| Returns the current value of the parameter as a String.
virtual StringArray | getAllValueStrings () const
| Returns the set of strings which represent the possible states a parameter can be in.
int | getVersionHint () const
void | setOwner (Listener *listener) noexcept
void | addListener (Listener *newListener)
| Registers a listener to receive events when the parameter's state changes.
void | removeListener (Listener *listener)
| Removes a previously registered parameter listener.
void | sendValueChangedMessageToListeners (float newValue)

## Protected Member Functions

virtual void | valueChanged (int newValue)
| Override this method if you are interested in receiving callbacks when the parameter value changes.

## Additional Inherited Members

Public Types inherited from juce::AudioProcessorParameter
enum | Category { genericParameter = (0 << 16) | 0 , inputGain = (1 << 16) | 0 , outputGain = (1 << 16) | 1 , inputMeter = (2 << 16) | 0 , outputMeter = (2 << 16) | 1 , compressorLimiterGainReductionMeter = (2 << 16) | 2 , expanderGateGainReductionMeter = (2 << 16) | 3 , analysisMeter = (2 << 16) | 4 , otherMeter = (2 << 16) | 5 }
Static Public Member Functions inherited from juce::AudioProcessorParameter
static int | getDefaultNumParameterSteps () noexcept
| Returns the default number of steps for a parameter.
Public Attributes inherited from juce::AudioProcessorParameterWithID
const String | paramID
| Provides access to the parameter's ID string.
const String | name
| Provides access to the parameter's name.
const String | label
| Provides access to the parameter's label.
const Category | category
| Provides access to the parameter's category.

## Constructors and Destructors

## AudioParameterInt() [1/2]

juce::AudioParameterInt::AudioParameterInt | ( | const ParameterID & | parameterID,
|  | const String & | parameterName,
|  | int | minValue,
|  | int | maxValue,
|  | int | defaultValue,
|  | const AudioParameterIntAttributes & | attributes = {} )

Creates a AudioParameterInt with the specified parameters.

Note that the attributes argument is optional and only needs to be supplied if you want to change options from their default values.

Example usage:

auto attributes = AudioParameterIntAttributes().withStringFromValueFunction ([] (auto x, auto) { return String (x); })
.withLabel ("things");
auto param = std::make_unique<AudioParameterInt> ("paramID", "Parameter Name", 0, 100, 50, attributes);
juce::AudioParameterIntAttributes
Properties of an AudioParameterInt.
Definition juce_AudioParameterInt.h:44
juce::RangedAudioParameterAttributes::withStringFromValueFunction
auto withStringFromValueFunction(StringFromValue x) const
An optional lambda function that converts a non-normalised value to a string with a maximum length.
Definition juce_RangedAudioParameter.h:63
juce::String
The JUCE String class!
Definition juce_String.h:67
x
float x
Definition juce_UnityPluginInterface.h:197

Parameters

  parameterID | The parameter ID to use
  parameterName | The parameter name to use
  minValue | The minimum parameter value
  maxValue | The maximum parameter value
  defaultValue | The default value
  attributes | Optional characteristics

Referenced by AudioParameterInt(), operator=(), and valueChanged().

## AudioParameterInt() [2/2]

juce::AudioParameterInt::AudioParameterInt | ( | const ParameterID & | parameterID,
|  | const String & | parameterName,
|  | int | minValue,
|  | int | maxValue,
|  | int | defaultValueIn,
|  | const String & | parameterLabel,
|  | std::function< String(int value, int maximumStringLength)> | stringFromInt = nullptr,
|  | std::function< int(const String &text)> | intFromString = nullptr )

inline

Creates a AudioParameterInt with the specified parameters.

Parameters

  parameterID | The parameter ID to use
  parameterName | The parameter name to use
  minValue | The minimum parameter value
  maxValue | The maximum parameter value
  defaultValueIn | The default value
  parameterLabel | An optional label for the parameter's value
  stringFromInt | An optional lambda function that converts an int value to a string with a maximum length. This may be used by hosts to display the parameter's value.
  intFromString | An optional lambda function that parses a string and converts it into an int. Some hosts use this to allow users to type in parameter values.

References AudioParameterInt().

## ~AudioParameterInt()

juce::AudioParameterInt::~AudioParameterInt | ( |  | ) |

override

Destructor.

## Member Functions

## get()

int juce::AudioParameterInt::get | ( |  | ) | const

inline noexcept

Returns the parameter's current value as an integer.

References juce::roundToInt().

Referenced by operator int().

## operator int()

juce::AudioParameterInt::operator int | ( |  | ) | const

inline noexcept

Returns the parameter's current value as an integer.

References get().

## operator=()

AudioParameterInt & juce::AudioParameterInt::operator= | ( | int | newValue | ) |

Changes the parameter's current value to a new integer.

The value passed in will be snapped to the permitted range before being used.

References AudioParameterInt().

## getRange()

Range< int > juce::AudioParameterInt::getRange | ( |  | ) | const

inline noexcept

Returns the parameter's range.

References getNormalisableRange().

## getNormalisableRange()

const NormalisableRange< float > & juce::AudioParameterInt::getNormalisableRange | ( |  | ) | const

inline override virtual

Returns the range of values that the parameter can take.

Implements juce::RangedAudioParameter.

Referenced by getRange().

## valueChanged()

virtual void juce::AudioParameterInt::valueChanged | ( | int | newValue | ) |

protected virtual

Override this method if you are interested in receiving callbacks when the parameter value changes.

References AudioParameterInt().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited